<template>
    <div>
        <PlaceholderField :placeholder="placeholder" />
        <input
            v-model="numberValue"
            type="number"
            min="0"
            @input="$input"
            :disabled="disabled"
        />
        <ErrorsField :errors="locErrors" />
    </div>
</template>

<script>
import ErrorsMixin from "@/mixins/errorsMixin";
import ErrorsField from "@/components/ErrorsField";
import PlaceholderField from "@/components/PlaceholderField";

export default {
    name: "QuestNumber",
    components: { PlaceholderField, ErrorsField },
    props: { value: [Number, String], placeholder: String, disabled: Boolean },
    mixins: [ErrorsMixin],
    computed: {
        numberValue: {
            get() {
                return Number(this.value);
            },
            set(value) {
                this.$emit("input", Number(value));
            },
        },
    },
    watch: {
        value: {
            immediate: true,
            handler(v) {
                if (v === null) this.numberValue = 0;
            },
        },
    },
};
</script>

<style scoped></style>
